]> git.wh0rd.org - home.git/blob - .bin/backup-dvd
55b622e608291a946a43971b110fbc5504b13662
[home.git] / .bin / backup-dvd
1 #!/bin/bash
2
3 err() { printf 'error: %b\n' "$*" 1>&2; exit 1; }
4 usage() {
5 cat <<-EOF
6 backup-dvd [options] [commands]
7
8 Options:
9 -i <input dev> Defaults to ${dev}
10 -o <output dir> Defaults to ${out}
11 -n <volume name> Defaults to volume on disk
12
13 Commands:
14 --errors Image the raw disc first w/ddrescue
15 --backup Back up the disc
16 --modify Tweak runtime settings (needs -n)
17 --mkiso Create an iso (needs -n)
18
19 If no commands are specified, then all are run.
20 EOF
21 exit ${1:-0}
22 }
23
24 dev=/dev/cdrom
25 out=${PWD}
26 vol=
27
28 unset doit_{backup,modify,mkiso}
29 doit_errors=false
30
31 eval set -- `getopt -l errors,backup,modify,mkiso -- hi:n:o: "$@"`
32 while [[ -n $1 ]] ; do
33 case $1 in
34 -h) usage;;
35 -i) dev=$2; shift 2;;
36 -o) out=$2; shift 2;;
37 -n) vol=$2; shift 2;;
38
39 --errors) doit_errors=true; shift;;
40 --backup) doit_backup=true; shift;;
41 --modify) doit_modify=true; shift;;
42 --mkiso) doit_mkiso=true; shift;;
43
44 --) shift; break;;
45 -*) usage 1;;
46 *) usage 2; break;;
47 esac
48 done
49
50 doit_all() {
51 : ${doit_backup:=$1}
52 : ${doit_modify:=$1}
53 : ${doit_mkiso:=$1}
54 }
55 if [[ -z ${doit_backup}${doit_modify}${doit_mkiso} ]] ; then
56 doit_all true
57 else
58 doit_all false
59 fi
60
61 # iso-info mkisofs
62 Application= # -A
63 Preparer= # -p
64 Publisher= # -publisher
65 System= # -sysid
66 Volume=${vol} # -V
67 Volume_Set= # -volset
68
69 if ${doit_backup} ; then
70 if [[ -z ${Volume} ]] ; then
71 info=$(iso-info ${dev}) || exit 1
72
73 eval $(echo "${info}" | awk -F: '
74 (NF > 1 && $1 !~ /image/) {
75 sub(/ *$/, "", $1);
76 sub(/ /, "_", $1);
77 sub(/^ */, "", $2);
78 print $1 "=\"" $2 "\"";
79 }')
80 fi
81
82 if [[ -z ${Volume} ]] ; then
83 echo "Unable to parse Volume out of ISO"
84 iso-info ${dev}
85 fi
86
87 for v in Application Preparer Publisher System Volume Volume_Set ; do
88 echo "${v}='${!v}'"
89 done > "${out}/.${Volume}.vars.sh"
90 else
91 [[ -z ${Volume} ]] && err "Need to specify -n with --modify/--mkiso"
92 . "${out}/.${Volume}.vars.sh" || exit 1
93 fi
94
95 e() {
96 for a ; do
97 [[ ${a} == *" "* || ${#a} == 0 ]] && fmt='"%s"' || fmt='%s'
98 printf "${fmt} " "${a}"
99 done
100 echo
101 "$@"
102 }
103
104 #
105 # Mirror the disc w/ddrescue which tolerates errors.
106 #
107 raw_read_dvd() {
108 echo "Imaging disc"
109 local raw=".${Volume}.raw"
110 local log="${raw}.log"
111 local opts=(
112 -v -b 2048 ${dev} "${raw}" "${log}"
113 )
114 ddrescue -p -n "${opts[@]}"
115 ddrescue -d -r 3 "${opts[@]}"
116 ddrescue -d -r 3 -R "${opts[@]}"
117 dev=${raw}
118 }
119
120 #
121 # Backup the disc.
122 #
123 backup_dvd() {
124 echo "Backing up: ${Volume}"
125 local opts=(
126 -i ${dev}
127 -o "${out}"
128 -n "${Volume}"
129 )
130 if ! e dvdbackup -M "${opts[@]}" ; then
131 e dvdbackup -F "${opts[@]}" || exit 1
132 fi
133 sync
134 }
135
136 #
137 # Modify some of the runtime settings.
138 #
139 bytes_get() {
140 local pfx='0x' sep
141 while [[ $# -gt 3 ]]; do
142 case $1 in
143 "-p") pfx=$2;;
144 "-s") sep=$2;;
145 *) break;;
146 esac
147 shift 2
148 done
149 printf '%b' "${pfx}"
150
151 local file=$1 off=$2 num=${3:-1}
152 hexdump -v -n ${num} -s $((${off})) -e "1/1 \"%02x${sep}\"" "${file}"
153 }
154 bytes_set() {
155 local file=$1 off=$2
156 shift 2
157 (for b; do printf "\x${b#0x}"; done) | \
158 dd of="${file}" \
159 bs=1 seek=$((${off})) \
160 conv=notrunc status=none
161 }
162 dvdsec() {
163 # DVDs have sectors of 2048 bytes (2^11).
164 local file=$1 off=$2 num=${3:-4}
165 echo $(( $(bytes_get "${file}" "${off}" "${num}") << 11 ))
166 }
167
168 _check_ifo() {
169 # Back up the .IFO files before we edit them.
170 local ifo=$1 magic=$2
171 [[ -e ${ifo} ]] || return 1
172
173 if [[ $(bytes_get "${ifo}" 0 12) != "0x${magic}" ]] ; then
174 echo "not a VMG IFO file: ${ifo}"
175 return 1
176 fi
177 if [[ ! -e ${ifo}.bak ]] ; then
178 cp -a "${ifo}" "${ifo}.bak"
179 fi
180
181 return 0
182 }
183
184 check_changes() {
185 [[ -e ifodump ]] || return 0
186
187 local file=$1
188 ./ifodump -f "${file}.bak" > "${file}.bak.dmp"
189 ./ifodump -f "${file}" > "${file}.dmp"
190 diff -u "${file}.bak.dmp" "${file}.dmp" | sed -e 1d -e 2d > "${file}.diff"
191 local out=$(
192 grep '^[+-]' "${file}.diff" | \
193 grep -v \
194 -e '^-VMG Category:.*' \
195 -e '^+VMG Category: 00000000 (Region Code=ff)' \
196 -e '^[-+].*Title playback type:' \
197 -e '^-.*Title or time play:1' \
198 -e '^+.*Title or time play:0' \
199 -e '^-Prohibited user operations:' \
200 -e '^+Prohibited user operations: Angle Change, $' \
201 -e '^+Prohibited user operations: None$' \
202 | egrep -v -e '^[-+]([0-9a-f]{2} )+$'
203 )
204 rm "${file}".{{,bak.}dmp,diff}
205 if [[ -z ${out} ]] ; then
206 return 0
207 else
208 echo "error in ifo modification:"
209 echo "${out}"
210 return 1
211 fi
212 }
213
214 process_pgci() {
215 # http://dvdnav.mplayerhq.hu/dvdinfo/pgc.html
216 local file=$1 pgci_off=$2 indent=$3
217 local num_pgcs p pgc_off off
218
219 num_pgcs=$(bytes_get "${file}" ${pgci_off} 2)
220 for (( p = 0; p < num_pgcs; ++p )) ; do
221 pgc_off=$((
222 pgci_off +
223 $(bytes_get "${file}" $(( pgci_off + 8 + 8 * p + 4 )) 4)
224 ))
225 off=$(( pgc_off + 8 ))
226 pgc_puo=$(bytes_get "${file}" ${off} 4)
227 printf '%bpgc #%2i @ %#06x: %s: ' "${indent}" ${p} ${vmgm_pgc_off} ${pgc_puo}
228 new_pgc_puo=$(( pgc_puo & (1 << 22) )) # Keep angle field.
229 if [[ ${pgc_puo} -ne ${new_pgc_puo} ]] ; then
230 bytes_set "${file}" ${off} 0 $(printf '%x' $(( new_pgc_puo >> 16 ))) 0 0
231 echo "cleared"
232 else
233 echo "nothing to do"
234 fi
235 done
236 }
237
238 process_pgci_ut() {
239 # http://dvdnav.mplayerhq.hu/dvdinfo/ifo_vts.html#pgciut
240 local file=$1 pgci_ut_off=$2
241 local num_langs l off
242
243 num_langs=$(bytes_get "${file}" ${pgci_ut_off} 2)
244 for (( l = 0; l < num_langs; ++l )) ; do
245 off=$((
246 pgci_ut_off +
247 $(bytes_get "${file}" $(( pgci_ut_off + 8 + 8 * l + 4 )) 4)
248 ))
249 printf '\tclearing lang #%i @ %#06x\n' ${l} ${off}
250 process_pgci "${file}" ${off} '\t\t'
251 done
252 }
253
254 process_vmgi() {
255 # Back up the .IFO files before we edit them.
256 local vmgi=$1
257 _check_ifo "${vmgi}" "445644564944454f2d564d47" || return 1
258
259 echo "${vmgi}"
260
261 # Clear the region code.
262 # http://dvdnav.mplayerhq.hu/dvdinfo/ifo.html
263 # 0x23 - region code restrict byte - set to 0x00 for region free.
264 echo "clearing region code"
265 bytes_set "${vmgi}" 0x23 0x00
266
267 # Clear all Prohibited User Operations (PUOs) in TT_SRPT (Uop1 & Uop0).
268 # http://dvdnav.mplayerhq.hu/dvdinfo/ifo_vmg.html
269 echo "clearing PUOs in TT_SRPT"
270 tt_srpt_sec=$(dvdsec "${vmgi}" 0xC4)
271
272 num_titles=$(bytes_get "${vmgi}" ${tt_srpt_sec} 2)
273 for (( t = 0; t < num_titles; ++t )) ; do
274 off=$(( tt_srpt_sec + 8 + (t * 12) ))
275 printf "\ttitle type #%2i @ %#06x: " "${t}" "${off}"
276 title_type=$(bytes_get "${vmgi}" ${off} 1)
277 uop0=$(( title_type & 1 ))
278 uop1=$(( title_type & 2 ))
279 printf "%s (uop1:%i uop0:%i): " ${title_type} ${uop1} ${uop0}
280 new_title_type=$(( title_type & ~3 ))
281 if [[ ${title_type} -ne ${new_title_type} ]] ; then
282 bytes_set "${vmgi}" ${off} $(printf '%x' ${new_title_type})
283 echo "cleared"
284 else
285 echo "nothing to do"
286 fi
287 done
288
289 # Clear all the PUOs in the PGCs. But Preserve the angle bit.
290 # Note: Removal of the angle PUO can cause certain standalone players to
291 # display the "angle" icon during playback. Removal of the angle PUO
292 # whilst permitted is therefore not recommended.
293 # http://dvdnav.mplayerhq.hu/dvdinfo/uops.html
294 #fp_pgc_addr=$(bytes_get "${vmgi}" 0x84 4)
295 #num_pgcs=$(bytes_get "${vmgi}" $(( fp_pgc_sec + 1 )) 1)
296 echo "clearing PUOs in PGCs"
297 vmgm_pgci_ut_sec=$(dvdsec "${vmgi}" 0xC8)
298 process_pgci_ut "${vmgi}" ${vmgm_pgci_ut_sec}
299 }
300
301 process_vtsi() {
302 # Back up the .IFO files before we edit them.
303 local vtsi=$1
304 _check_ifo "${vtsi}" "445644564944454f2d565453" || return 1
305
306 echo "${vtsi}"
307
308 echo "clearing PUOs in PGCs"
309
310 vts_pgci_sec=$(dvdsec "${vtsi}" 0xCC)
311 process_pgci "${vtsi}" ${vts_pgci_sec} '\t'
312
313 vtsm_pgci_ut_sec=$(dvdsec "${vtsi}" 0xD0)
314 process_pgci_ut "${vtsi}" ${vtsm_pgci_ut_sec}
315 }
316
317 modify_dvd() {
318 local out_vts_dir="${out}/${Volume}/VIDEO_TS"
319 local vmgi vtsi
320
321 if ${doit_errors} ; then
322 echo "skipping modifications due to possible errors in files"
323 return
324 fi
325
326 for vmgi in "${out_vts_dir}"/VIDEO_TS.{IFO,BUP} ; do
327 process_vmgi "${vmgi}"
328 check_changes "${vmgi}" || exit 1
329 done
330
331 for vtsi in "${out_vts_dir}"/VTS_??_?.{IFO,BUP} ; do
332 process_vtsi "${vtsi}"
333 check_changes "${vtsi}" || exit 1
334 done
335 }
336
337 #
338 # Finally, create a new iso.
339 #
340 mkiso_dvd() {
341 set -- mkisofs -quiet -dvd-video -no-bak \
342 -A "${Application}" \
343 -p "${Preparer}" \
344 -publisher "${Publisher}" \
345 -sysid "${System}" \
346 -V "${Volume}" \
347 -volset "${Volume_Set}" \
348 -o "${Volume}.iso" "${Volume}"
349 sh="${out}/.${Volume}.sh"
350 (
351 echo "#!/bin/sh"
352 echo "cd '${out}' || exit 1"
353 echo ". './.${Volume}.vars.sh'"
354 printf 'set -- '
355 printf '%q ' "$@"
356 echo
357 echo 'echo "$@"; exec "$@"'
358 ) > "${sh}"
359 chmod a+x "${sh}"
360 "${sh}" || exit
361 sync
362 md5sum "${out}/${Volume}.iso" > "${out}/${Volume}.md5"
363
364 du -h "${out}/${Volume}.iso"
365 sudo chattr +i "${out}/${Volume}.iso"
366 sync
367 }
368
369 ${doit_errors} && raw_read_dvd
370 ${doit_backup} && backup_dvd
371 ${doit_modify} && modify_dvd
372 ${doit_mkiso} && mkiso_dvd
373
374 ${doit_backup} && eject
375 exit 0